import Sav.Z.*;
import java.io.*;
/**
 * The example stops printing that a few Sessions do.
 */
class CommutatorDemo extends Session implements Runnable {
  public static void main(String arg[]) throws Exception {
    Session ss0 = new Session();
    ss0.modifyBase("Data");
    ss0.z("$base ~");
    for (int i = 0; i < 200; ++i) {
      ss0.z("Data:#");
    }
    ss0.closeBase("Data");
    String text =
      "= $base Data;\n" +
      "$p(Data:);\n"
    ;
    /***********************/
    Commutator comm = new Commutator();
    for (int i = 0; i < 5; ++i) {
      CommutatorDemo ss = new CommutatorDemo(text, i);
      ss.setCommutator(comm);
      new Thread(ss).start();
    }
    Thread.sleep(4000);
    comm.setOff(true);
    /***********************/
  }

  String text;
  int number;
  CommutatorDemo(String text, int number) throws IOException {
    super();
    this.text = text;
    this.number = number;
    MyPrinter prt = new MyPrinter("Session " + number + ": ");
    setReportPrinter(prt);
  }
  public void run() {
    z(text);
  }

  public class MyPrinter extends ConsolePrinter {
    String info;
    MyPrinter(String info) {
      super();
      this.info = info;
    }
    public void println(String s) {
      super.println(info + s);
    }
  }

}